import win32com, sys, string, win32api, traceback, re, tempfile, os
import win32com.client.dynamic
from win32com.test.util import CheckClean
import pythoncom
from win32com.client import gencache
from pywintypes import Unicode
from stat import *

class MSWordDoc:
	def __init__(self, name, data):
		"Initialization : create tmp work directory and copy the document into a file."
		self.name = name
		self.data = data
		self.tmpdir = tempfile.mktemp()
		os.mkdir(self.tmpdir)
		filedest = open("%s\%s.doc" % (self.tmpdir, self.name), "wb")
		filedest.write(data)
		filedest.close()
	
	def Convert(self):
		file = "%s\%s.doc" % (self.tmpdir, self.name)
		pythoncom.CoInitialize()
		self.word = win32com.client.dynamic.Dispatch("Word.Application")
		self.word.Visible = 0
		self.doc = self.word.Documents.Open(file)
		self.doc.SaveAs(FileName="%s\%s.htm" % (self.tmpdir, self.name), FileFormat=8)
		self.word.Quit()
		win32api.Sleep(1000) #Waiting for Word to close
		#blah blah blah
		pythoncom.CoUninitialize()

## This function has to be done. It's more difficult to delete the temp
## directory under Windows, because there is sometimes a directory in it.
##	def cleandir(self):
##		if self.filesdir:
##			for f in os.listdir("%s\%s" % (self.tmpdir, self.filesdir)):
##				os.remove("%s\%s\%s" % (self.tmpdir, self.filesdir, i))
##			os.rmdir("%s\%s" % (self.tmpdir, self.filesdir))
##		for f in os.listdir(self.tmpdir):
##			os.remove("%s\%s" % (self.tmpdir, i))
##		os.rmdir(self.tmpdir)

	def getDocHTML(self):
		html = open("%s\%s.htm" % (self.tmpdir, self.name), 'r').read()
		return html

	def getImgs(self):
		imgs = {}
		for f in os.listdir(self.tmpdir):
			#find the directory containing the images
			if S_ISDIR(os.stat('%s\%s' % (self.tmpdir, f))[ST_MODE]):
				for i in os.listdir("%s\%s" % (self.tmpdir, f)):
					result = re.match("^.+\.(?P<ext>.+)$", i)
					ext = result.group('ext') 
					if ext in ('png', 'jpg', 'gif', 'wmz'):
						imgs[i] = open("%s\%s\%s" % (self.tmpdir, f, i)).read()
		return imgs

		